int cat_img_num = 49;
PImage[] cat_img = new PImage[cat_img_num];
int BASE1_START = 0;
int BASE1_END = 4;
int BASE2_START = 6;
int BASE2_END = 15;
int extra_start;
int BABY = 43;
int SUPER = 45;
int MIGRATED = 48;

int born_ground_cats = 0;
class Cat{
  int img_index;
  Movement mv; 
  Cat(int option){
    if(option == 0){
      if(born_ground_cats != 0 && born_ground_cats % 5 == 0)
        img_index = SUPER;
      else if(born_ground_cats < 5)
        img_index = (int)random(BASE1_START, BASE1_END + 1);
      else if (born_ground_cats < 20)
        img_index = (int)random(BASE2_START, BASE2_END + 1);
      else {
        if (born_ground_cats % 5 == 1)
          extra_start = (int)random(0,5) * 5 + 18;
        if((int)random(0, 20) == 0) img_index = BABY;
        else img_index = extra_start + (int)random(0,5);
      }
      born_ground_cats++;
      mv = null;
    } else {
      img_index = SUPER + option;
      mv = new Movement(flying_cat_pos1, flying_cat_pos2, true);
    }
  }
  
  Pos Here(){
    int i = 0;
    while(cat_pos[i].cat != this)
      i++;
    return cat_pos[i];
  }
  
  Pos Next(){
    int i = 0;
    while(cat_pos[i].cat != this)
      i++;
    return (i+1 == pos_num)? null : cat_pos[i+1];
  }
  
  void InitMove()
  {
    if(mv != null) return;
    if(Next() == null) return;
    if(Next().cat == null && Here().y <= Next().y)
        mv = new Movement(Here(), Next(), false);
  }
  void Move()
  {
    if(mv == null) return;
    mv.Transit();
    if(mv.transition >= 1){
      if(mv.is_flying) {
        flying_cat_pos2.cat = this;
        flying_cat_pos1.cat = null;
        mv = new Movement(flying_cat_pos2, flying_cat_pos2, true);
      }
      else {
        Next().cat = this;
        Here().cat = null;
        mv = null;
        if(Here() == cat_pos[center_pos_index + 1]){
          if(img_index == BASE1_END || img_index == BABY)
            img_index++;
          else if(img_index == BASE2_END - 1 || img_index == BASE2_END)
            img_index += 2;
        }
      }
    }
  }
  
  float height_offset = -0.05*height, sizeX = 0.15*width, sizeY = 0.15*height;
  void Display()
  {
    float x= mv==null ? Here().x : mv.moving_x();
    float y= mv==null ? Here().y : mv.moving_y();
    imageMode(CENTER);
    image(cat_img[img_index], x, y+height_offset, sizeX, sizeY);
    imageMode(CORNER);
  }
  void Draw()
  {
    InitMove();
    Move();  
    Display();
  }
}